{########################################################################################################################################################}
// Zobrazeni vysledku
procedure ShowResult(Show: Boolean);
begin
  LogWork(_('Result showed'));
  //Updated
  EndForm_gb_Updated     .Enabled := NumOfUpdated > 0;
  EndForm_tp_NumOfUpdated.Caption := IntToStr(NumOfUpdated);
  EndForm_tp_NumOfUpdated.Enabled := EndForm_gb_Updated.Enabled;
  EndForm_cb_ShowList_Upd.Enabled := EndForm_gb_Updated.Enabled;
  if EndForm_gb_Updated.Enabled then begin 
    EndForm_gb_Updated.Font.Color      := clWindowText;
    EndForm_tp_NumOfUpdated.Font.Color := clWindowText;
  end
  else begin 
    EndForm_gb_Updated.Font.Color      := clSilver;
    EndForm_tp_NumOfUpdated.Font.Color := clSilver;
  end;
  //Imported
  EndForm_gb_Imported     .Enabled := NumOfImported > 0;
  EndForm_tp_NumOfImported.Caption := IntToStr(NumOfImported);
  EndForm_tp_NumOfImported.Enabled := EndForm_gb_Imported.Enabled;
  EndForm_cb_ShowList_Imp .Enabled := EndForm_gb_Imported.Enabled;
  if EndForm_gb_Imported.Enabled then begin 
    EndForm_gb_Imported.Font.Color      := clWindowText;
    EndForm_tp_NumOfImported.Font.Color := clWindowText;
  end
  else begin 
    EndForm_gb_Imported.Font.Color      := clSilver;
    EndForm_tp_NumOfImported.Font.Color := clSilver;
  end;
  // EndForm - FN
  EndForm_gb_FN         .Enabled := NumOfFN > 0;
  EndForm_tp_NumOfFN    .Caption := IntToStr(NumOfFN);
  EndForm_tp_NumOfFN    .Enabled := EndForm_gb_FN.Enabled;
  EndForm_cb_ShowList_FN.Enabled := EndForm_gb_FN.Enabled;
  if EndForm_gb_FN.Enabled      then begin 
    EndForm_gb_FN.Font.Color            := clWindowText;
    EndForm_tp_NumOfFN.Font.Color       := clWindowText;
  end
  else begin 
    EndForm_gb_FN.Font.Color            := clSilver;
    EndForm_tp_NumOfFN.Font.Color       := clSilver;
  end;
  // EndForm - Filtr
  EndForm_cb_ShowList_ggfName.Enabled   := EndForm_cb_ShowList_ggf      .Checked;

  if Show then begin 
    if EndForm.ShowModal = 1 then begin
      SaveIniEndForm('DEFAULT');   // Ulozi parametry z formulare GeoQuackSyn_End.gfm
    end;
  end;
end;

{########################################################################################################################################################}
{## PDA -> PC ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_PDA_PC(Sender: TObject);
var 
  script : string;
  id     : TStringList;
  m      : integer;
  ResultOK : boolean;
begin
  GQSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('PDA to PC sync'));
  SaveProfile('DEFAULT');
  if GQCard then begin                     //pokud je spravne nastaven disk s GQ
    ReadGQini(True, GQSForm_rb_CardReader.Checked); // Nacteni nastaveni GeoQuack z ini
    // Priprava databaze GeoQuack
    if GQSForm_rb_db_GQ_Custom.Checked then begin
      dbName := GQSForm_cmb_db_GQ_CustomName.Text + '.db3';
      dbFile := dbPath + '\' + dbName;
      LogWork(_('- Custom GeoQuack database: ') + dbFile);
    end;

    // Prenos FieldNotes z PDA do PC (GeoQuack -> GeoGet) - prenese obsah cele slozky
    if UpdGGForm_cb_Upd_FieldNotes.Checked and not GQSForm_rb_Offline.Checked then begin
      GB_Caption(_('Transfer FieldNotes from GeoQuack'));
      if FNFile <> '' then begin
        GB_Kind(_('FieldNotes from PDA to PC are copied...'));
        MakeDirPC(SmartPath(FNPathPC));
        ResultOK := False;
        if GQSForm_rb_CardReader.Checked then begin    //CardReader
          ResultOK := CopyFile(ToCardPath(FNFile), SmartPath(FNPathPC) +'\FieldNotes_GQ.txt');
          if UpdGGForm_cb_Del_FieldNotes.Checked then DeleteFile(ToCardPath(FNFile));
        end;
        if GQSForm_rb_FTP       .Checked then begin    //FTP
          ResultOK := FtpGetFile(SetForm_ed_FTP_IP.Text, SetForm_ed_FTP_Port.Text, 'mnt/sdcard/' + ReplaceString(FNFile,'\','/'), SmartPath(FNPathPC) +'\FieldNotes_GQ.txt', SetForm_ed_FTP_User.Text, SetForm_ed_FTP_Pswd.Text);
        end;
        if ResultOK then begin
          LogWork(    _('= FieldNotes from PDA to PC transferred'));
        end
        else begin
          LogWork(    _('# Transfer FieldNotes from PDA to PC failed!'));
          ShowMessage(_('# Transfer FieldNotes from PDA to PC failed!'));
        end;
      end
      else begin
        ShowMessage(_('Location of FieldNotes failed!')+CRLF+
                    _('Check settings of GeoQuack (Export FieldNotes/File for export).')+CRLF+
                    _('FieldNotes not transferred!'));
        LogWork(_('# Error: FieldNotes from PDA to PC not transferred!'));
      end;
     GB_Clean;
    end;

    // Prenos Tracks z PDA do PC (GeoQuack -> GeoGet) - prenese obsah cele slozky
    if UpdGGForm_cb_Upd_Tracks.Checked and not GQSForm_rb_Offline.Checked then begin
      GB_Caption(_('Transfer Tracks from GeoQuack'));
      if TrackPath <> '' then begin
        GB_Kind(_('Tracks from PDA to PC are copied...'));
        MakeDirPC(SmartPath(TrackPathPC));
        if GQSForm_rb_CardReader.Checked then begin    //CardReader
          CopyTree(ToCardPath(TrackPath), SmartPath(TrackPathPC));
          LogWork(    _('= Tracks from PDA to PC transferred'));
          if UpdGGForm_cb_Del_Tracks.Checked then DeleteFiles(ToCardPath(TrackPath) + '\*.*');
        end;
        if GQSForm_rb_FTP       .Checked then begin    //FTP
        end;
      end
      else begin
        ShowMessage(_('Location of Tracks failed!')+CRLF+
                    _('Check settings of GeoQuack (Export Track/Folder for export).')+CRLF+
                    _('Tracks not transferred!'));
        LogWork(_('# Error: Tracks from PDA to PC not transferred!'));
      end;
    GB_Clean;
    end;

    // Aktualizace databaze z PDA do PC (GeoQuack -> GeoGet)
    if GQSForm_cb_Upd_db_GG.Checked and not GQSForm_rb_Offline.Checked then begin
      LogWork(_('* Update GeoGet database from GeoQuack database'));
      if (('GQ_' + dbName) <> (GQSForm_lbl_db_GG_Name.Caption + '.db3')) then begin
        GB_Caption(_('Database from GeoQuack is loaded'));
        GB_Kind(_('copying: ') + dbName + '...');
        ResultOK := False;
        if GQSForm_rb_CardReader.Checked then ResultOK := CopyFile(ToCardPath(dbFile), GEOGET_DATADIR + '\GQ_' + dbName);
        if GQSForm_rb_FTP       .Checked then ResultOK := FtpGetFile(SetForm_ed_FTP_IP.Text, SetForm_ed_FTP_Port.Text, 'mnt/sdcard/' + ReplaceString(dbfile,'\','/'), GEOGET_DATADIR + '\GQ_' + dbName, SetForm_ed_FTP_User.Text, SetForm_ed_FTP_Pswd.Text);
        if ResultOK then begin
          LogWork(_('- main database from PDA to PC transfered'));
          SaveIniFloatValue('DEFAULT', 'db_LastUpload', now);                                
          GeoDBSelect('GQ_' + ReplaceString(dbName, '.db3', ''));
          // vyfiltrovani kesi, u kterych doslo ke zmene od zadaneho datumu
          try
            id:=TStringList.Create;
// #==#     GEOGET_DB.GetTableStrings('SELECT id FROM geocache WHERE dtupdate2 >= ' + FlToStr(GQSForm_dt_db_LastUpdate_Date.Date + GQSForm_dt_db_LastUpdate_Time.Time), id);
            script := ''; NumOfUpdated := 0;
            for m:=0 to (id.count-1) do begin
              script := script + id[m] + CRLF;
              NumOfUpdated := NumOfUpdated + 1;
            end;
            StringToFile(script, MakroPath + 'Data\GeoList_Upd.ggt');
          finally
            id.free;
            LogWork(_('- updated geocaches selected'));
          end;
          // priprava seznamu pro export
          GeoListClear;
          GeoListFileAdd(MakroPath + 'Data\GeoList_Upd.ggt');
          // export zmen do gpx souboru
          GB_Kind(_('changes are exporting...'));
          GeoExport(GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas', MakroPath + 'Data\Geo_Upd.gpx');
          LogWork(_('- updated geocaches exported to "Data\Geo_Upd.gpx"'));
          GeoDBSelect(GQSForm_lbl_db_GG_Name.Caption);          // prepne na aktivni databazi
          if not UpdGGForm_cb_Save_db_GQ.Checked then DeleteFiles(GEOGET_DATADIR + '\GQ_' + ReplaceString(dbName, '.db3', '*'));
          // import zmen z gpx souboru do aktivni databaze
          GB_Kind(_('changes are imported to database ') + GQSForm_lbl_db_GG_Name.Caption);
          GeoImportFile(MakroPath + 'Data\Geo_Upd.gpx');
          LogWork(_('= GeoGet database updated from GeoQuack database'));
        end
        else begin
          LogWork    (_('# Transfer GeoGet database "') + dbfile + _('" from PDA failed!'));
          ShowMessage(_('# Transfer GeoGet database "') + dbfile + _('" from PDA failed!'));
        end;
        GB_Clean;
      end
      else begin
        ShowErrorMessage(_('Database transfer "') + GQSForm_lbl_db_GG_Name.Caption + _('" does not have to done!')+CRLF+
                         _('Database name from GeoQuack is the same as current GeoGet database.')+CRLF+
                         _('Select other GeoGet database!'));
        LogWork(_('# Error: Database from PDA to PC not transferred! Names of GeoQuack and GeoGet database are the same.'));
      end;
    end;

    if Sender <> GQSForm_btn_All then ShowResult(True);
  end;
  GQSForm.Show;
end;


{########################################################################################################################################################}
{## PC -> Web ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_PC_Web(Sender: TObject);
var 
  script         : string;
  path           : string;
  template       : string;
  tmp            : string;
  err            : string;
  Ini_gjFN       : TIniFile;    // INI soubor FieldNotes pro GeoJarry
  id             : TStringList;
  m              : integer;
  n              : integer;
  // FN z databaze GG
  idFound        : TStringList;
  dtOfLog        : TDateTime;
  TypeOfLog      : string;
  LogIsFoundIt   : boolean;
  FNText         : string;
begin
  GQSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('PC to Web sync'));
  SaveProfile('DEFAULT');

    // Generovat FieldNotes z databaze GeoGetu
    if GQSForm_cb_Gen_FieldNotes_GG.Checked then begin
      GB_Caption(_('FieldNotes from current GeoGet database are genetated'));
      GB_Kind(_('only records from ') + FormatDateTime('dd"."mm"."yyyy" "hh":"nn', GQSForm_dt_FN_LastUpdate_Date.Date + GQSForm_dt_FN_LastUpdate_Time.Time));
      // ziskani kesi, u kterych doslo ke zmene po zadanem datumu a maji nejake FN
      try
        id:=TStringList.Create;
        script := DateToInt(GQSForm_dt_FN_LastUpdate_Date.Date) + '-' + FormatDateTime('hhnn', GQSForm_dt_FN_LastUpdate_Time.Time);
        GEOGET_DB.GetTableStrings('SELECT geocache.id ' +
                                  'FROM geocache, geotag, geotagcategory, geotagvalue ' +
                                  'WHERE geocache.id = geotag.id AND geotag.ptrkat = geotagcategory.key AND geotag.ptrvalue = geotagvalue.key AND geotagcategory.value = "fieldnotetime" ' +
                                  'AND geotagvalue.value >= "' + script + '"', id);
        LogWork(_('- geocaches with fieldnotetime tag >= ') + script + _(' selected'));
        idFound:=TStringList.Create;
        Geoget_DB.GetTableStrings('SELECT id FROM geocache WHERE dtfound<>0 ORDER BY dtfound,dtfoundtime',idFound);  // naplni tabulku vsech owner nalezu
        LogWork(_('- owner`s all FoundIt logs = ') + IntToStr(idFound.Count));
        GB_Caption(_('FieldNotes from current GeoGet database are genetated'));
        GB_Kind(_('only records from ') + FormatDateTime('dd"."mm"."yyyy" "hh":"nn', GQSForm_dt_FN_LastUpdate_Date.Date + GQSForm_dt_FN_LastUpdate_Time.Time));
        GC:= TGeo.Create();
        script := ''; FNText := ''; NumOfFN := 0;
        for m:=0 to (id.count-1) do begin
          if GB_Test then Break;  //preruseno uzivatelem
          GeoBusyProgress(m, id.count)
          GC.LoadByGC(id[m]);
          TypeOfLog := GC.TagValues('fieldnotetype');
          tmp       := GC.TagValues('fieldnotetime');
          dtOfLog      := IntToDate(copy(tmp,1,8)) + EncodeTime(StrToInt(copy(tmp,10,2)),StrToInt(copy(tmp,12,2)),0,0);
          LogIsFoundIt := RegexFind('(Found it|Found It)|found it', TypeOfLog);
          template := FNTemplate;       // nacte template pro FN z registru PDA (z nastaveni GeoQuack)
          template := ReplaceString(template,'[T]', formatdatetime('hh":"nn', dtOfLog));
          if LogIsFoundIt then begin
            for n:=0 to (idFound.count-1) do if idFound[n] = GC.ID then Template := ReplaceString(template,'[N]', IntToStr(n+1));
          end
          else template := RegexReplace('(\[N\]|#\[N\])', template, '', False);
          template := ReplaceString(template,'[L]', ReplaceString(GC.TagValues('fieldnote'), '//', CRLF));
          template := ReplaceString(template,'\x0d\x0a', CRLF);
          if dtOfLog >= (GQSForm_dt_FN_LastUpdate_Date.Date + GQSForm_dt_FN_LastUpdate_Time.Time)  then begin
            script := script + GC.id + CRLF;
            FNText := FNText + GC.id + ','+formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn"Z"', dtOfLog)+','+TypeOfLog+',"'+template+'"'+CRLF;
            NumOfFN := NumOfFN + 1;
          end;
        end;
        MakeDirPC(SmartPath(FNPathPC));
        StringToFile(FNText, SmartPath(FNPathPC) +'\FieldNotes_GG.txt');                // Ulozi FieldNotes soubor
        StringToFile(script, Makropath          + 'Data\GeoList_FN.ggt');               // Ulozi seznam kesi jako list.ggt pro pripadne pozdejsi nacteni
      finally
        GC.free;
        id.free;
        idFound.free;
      end;
      SaveIniFloatValue('DEFAULT', 'FN_LastUpdate', Now);                                
      LogWork(_('= FieldNotes from GeoGet database genetated = ') + IntToStr(NumOfFN));
      GB_Clean;
    end;

    // Upload FieldNotes na GC.com
    if GQSForm_cb_Upl_FieldNotes.Checked then begin
      GB_Caption(_('Upload FieldNotes on geocaching.com'));
      GB_Kind(_('looking for GeoJarry...'));
      err := '';
      {pohledame kde je geojarry.exe nebo geojarryw.exe a ulozime do GeojarryExe}
      tmp := SearchFile(GEOGET_DATADIR,'geojarryw.exe');
      if ((tmp <> _('File not found!')) and (FileExists(tmp))) then GeojarryExe := tmp
      else begin
        tmp := SearchFile(GEOGET_DATADIR,'geojarry.exe');
        if ((tmp <> _('File not found!')) and (FileExists(tmp))) then GeojarryExe := tmp;
      end;
      if GeojarryExe <> '' then begin
        LogWork(_('- GeoJarry found: ') + GeojarryExe);
        tmp := SearchFile(GEOGET_DATADIR,'groundspeak.config.pas');
        if ((tmp <> _('File not found!')) and (FileExists(tmp))) then begin
          LogWork(_('- GeoJarry config found: ') + tmp);
          GeojarryConfig := tmp;
          gjUsername := GetVariableValue(GeojarryConfig, 'gsUsername');
          gjPassword := GetVariableValue(GeojarryConfig, 'gsPassword');
          if (GjUsername <> '') and (GjPassword <> '') then begin
            // Provede vlastni upload
            GB_Kind(_('FieldNotes on geocaching.com are uploaded...'));
            MakeGeojarryIni('');
            Ini_gjFN := TIniFile.Create(MakroPath + 'FieldNotes_Upload.ini');
            if GQSForm_rb_Upl_FieldNotes_GG.Checked then path := SmartPath(FNPathPC) + '\FieldNotes_GG.txt'
                                                    else path := SmartPath(FNPathPC) + '\FieldNotes_GQ.txt';
            if FileExists(path) then begin
              Ini_gjFN.WriteString('form', 'ctl00$ContentBody$FieldNoteLoader', path);
              UploadOnGC;
            end
            else err := _('Error: File of FieldNotes not exists!')+CRLF+ path;
          end
          else err := _('Error: Check login items in groundspeak plugin manager settings!');
        end
        else err := _('Error: GeoJarry is installed incorrectly!')+CRLF+_('Not found "groundspeak.config.pas"');
      end
      else err := _('Error: "geojarry.exe" or "geojarryw.exe" not found!');
      if err = '' then LogWork(_('= FieldNotes on geocaching.com uploaded'))
                  else begin
                    ShowMessage(script);
                    LogWork('# ' + ReplaceString(err,CRLF,' '));
                    LogWork(_('# Error: FieldNotes on geocaching.com not uploaded!'));
                  end;
      MakeGeojarryIni('destroy');                           // odstrani heslo na gc.com z gjtemp.ini
      DeleteFiles(MakroPath + 'Data\*.setform.htm');        // odstrani html soubory po GeoJarrym
      GB_Clean;
    end;

    if Sender <> GQSForm_btn_All then ShowResult(True);
    GQSForm.Show;
end;

{########################################################################################################################################################}
{## PC -> PDA ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_PC_PDA(Sender: TObject);
var 
  script   : string;
  str      : string;
  x,y      : string;
  key      : string;
  ResultOK : boolean;
begin
  GQSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('PC to PDA sync'));
  SaveProfile('DEFAULT');
  if GQCard then begin                     //pokud je spravne nastaven disk s GQ
    ReadGQini(True, GQSForm_rb_CardReader.Checked); // Nacteni nastaveni GeoQuack z ini
    // Priprava databaze GeoQuack
    if GQSForm_rb_db_GQ_Custom.Checked then begin
      dbName := GQSForm_cmb_db_GQ_CustomName.Text + '.db3';
      dbFile := dbPath + '\' + dbName;
      LogWork(_('- Custom GeoQuack database: ') + dbFile);
    end;
    // Prenos databaze z PC do PDA (GeoGet -> GeoQuack)
    if GQSForm_cb_Upd_db_GQ.Checked and not GQSForm_rb_Offline.Checked then begin
      GB_Caption(_('Transfer database to PDA'));
      if (LoadIniFloatValue('DEFAULT', 'db_LastUpload', 0.0) + (1.0/24)) < now then begin
        ShowErrorMessage(_('Last uploaded database from GeoQuack is older than 1h! ')+CRLF+
                         _('Last upload: ')+FormatDateTime('dd.mm.yyyy hh:mm:ss', LoadIniFloatValue('DEFAULT', 'db_LastUpload', 0.0))+CRLF+CRLF+
                         _('Overwriting a database will delete FN and last changes!'));
      end;
      
      // vytvori pracovni databazi "$GeoQuack_Work$.db3" pro prenos do PDA
      dbWorkListCreate;  

      // Prepare reference points to GQ database
      if UpdGQForm_cb_GQ_Ref_points.Checked then begin
        GB_Kind(_('Reference points are preparing'));
        if FileExists(GEOGET_DATADIR + '/geohome.ini') then begin
          try
            GeoDBSelect('$GeoQuack_Work$');                // prepne na pracovni databazi
            SQLVersionTest(GEOGET_DB, '$GeoQuack_Work$');  // zkontroluje verzi databaze
            key := GEOGET_DB.GetTableString('SELECT key FROM geocache WHERE id="GC0"');
            if (key = '') then GEOGET_DB.ExecSQL('INSERT INTO geocache (id,guid,x,y,name,author,cachetype,cachesize,difficulty,terrain,dtupdate,dtupdate2,country,state,gs_cacheid,gs_ownerid) VALUES ("GC0","","0.0","0.0","GeoQuack","GeoQuack","Unknown Cache","Not chosen","0.1","0.1","'+DateToInt(date)+'","'+FloatToStr(now)+'","","","","")');
            script := AnsiToUtf(FileToString(GEOGET_DATADIR + '/geohome.ini'));
            while script <> '' do begin
              str := Fetch(script, CRLF);
              x := Trim(RegexExtract('^\S+' , str));
              y := Trim(RegexExtract(' \S+ ', str));
              str :=      ReplaceString(str, x, '');
              str := Trim(ReplaceString(str, y, ''));
              key := GEOGET_DB.GetTableString('SELECT key FROM waypoint WHERE id="GC0" AND name="' + str + '"');
              if (key = '') then begin
                key := '00';
                repeat
                  key := FormatFloat('00', (StrToFloat(key) + 1));
                until (GEOGET_DB.GetTableString('SELECT prefixid FROM waypoint WHERE id="GC0" AND prefixid="' + key + '"') = '');
                GEOGET_DB.ExecSQL('INSERT  INTO waypoint (id,guid,x,y,name,prefixid,lookup,wpttype,cmt,dtupdate,dtupdate2) VALUES ("GC0","","'+x+'","'+y+'","'+str+'","'+key+'","","Reference Point","","'+DateToInt(date)+'","'+FloatToStr(now)+'")');
              end
              else begin
                GEOGET_DB.ExecSQL('REPLACE INTO waypoint (key,x,y,dtupdate,dtupdate2) VALUES ("'+key+'","'+x+'","'+y+'","'+DateToInt(date)+'","'+FloatToStr(now)+'")');
              end;
            end;
          finally
            LogWork(_('- Reference Points prepared.'));
            GeoDBSelect(GQSForm_lbl_db_GG_Name.Caption);  // prepne na aktivni databazi
          end;
        end;
      end;   

      // odeslani hlavni databaze do PDA
      GB_Caption(_('Transfer database to PDA'));
      if GQSForm_rb_db_GG_Filter.Checked then GB_Kind(_('list is copied from database: "') + GQSForm_lbl_db_GG_Name.Caption + '"')
                                         else GB_Kind(_('copying of database: "')          + GQSForm_lbl_db_GG_Name.Caption + '"');
      GB_Kind(_('copying: ') + dbName + '...');
      ResultOK := False;
      if GQSForm_rb_CardReader.Checked then ResultOK := CopyFile(GEOGET_DATADIR + '\$GeoQuack_Work$.db3', ToCardPath(dbFile));
      if GQSForm_rb_FTP       .Checked then ResultOK := FtpPutFile(SetForm_ed_FTP_IP.Text, SetForm_ed_FTP_Port.Text, 'mnt/sdcard/' + ReplaceString(dbfile,'\','/'), GEOGET_DATADIR + '\$GeoQuack_Work$.db3', SetForm_ed_FTP_User.Text, SetForm_ed_FTP_Pswd.Text);
      if ResultOK then begin
        SaveIniFloatValue('DEFAULT', 'db_LastDownload', now);                                
        LogWork(_('= GeoGet database "$GeoQuack_Work$.db3" to PDA transfered'));
      end
      else begin
        LogWork(_('# Transfer GeoGet database "$GeoQuack_Work$.db3" to PDA failed!'));
      end;
      DeleteFiles(GEOGET_DATADIR+'\$GeoQuack_Work$*');   // odstrani pracovni databaze
      GB_Clean;
    end;

    // Synchronizace offline listingu)
    if GQSForm_cb_Sync_Img.Checked and not GQSForm_rb_Offline.Checked then begin
      GB_Caption(_('Offline listings are synchronized'));
      MakeDirPDA(MapPath + '\offline');           // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      MakeDirPDA(MapPath + '\offline\Cache');     // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      MakeDirPDA(MapPath + '\offline\Inc');       // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      MakeDirPDA(MapPath + '\offline\Img');       // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      MakeDirPDA(MapPath + '\offline\Maps');      // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      MakeDirPDA(MapPath + '\offline\SysImg');    // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      MakeDirPDA(MapPath + '\offline\Index');     // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      // vlastni synchronizace
      if GQSForm_rb_CardReader.Checked then begin
        SmartCopyPC(GEOGET_DATADIR + '\offline\cache'    , ToCardPath(MapPath) + '\offline\Cache'  , '.*', '- (1/6) ' +_('synchronizing listings, please wait...'));
        SmartCopyPC(GEOGET_DATADIR + '\offline\inc'      , ToCardPath(MapPath) + '\offline\Inc'    , '.*', '- (2/6) ' +_('synchronizing pictures of listings, please wait...'));
        SmartCopyPC(GEOGET_DATADIR + '\offline\img'      , ToCardPath(MapPath) + '\offline\Img'    , '.*', '- (3/6) ' +_('synchronizing shared pictures of listings, please wait...'));
        SmartCopyPC(GEOGET_DATADIR + '\offline\maps'     , ToCardPath(MapPath) + '\offline\Maps'   , '.*', '- (4/6) ' +_('synchronizing maps of listings, please wait...'));
        SmartCopyPC(GEOGET_DATADIR + '\offline\sysimg'   , ToCardPath(MapPath) + '\offline\SysImg' , '.*', '- (5/6) ' +_('synchronizing system pictures of listings, please wait...'));
        SmartCopyPC(GEOGET_DATADIR + '\offline\index'    , ToCardPath(MapPath) + '\offline\Index'  , '.*', '- (6/6) ' +_('synchronizing index of listings, please wait...'));
        CopyFile   (GEOGET_DATADIR + '\offline\index.htm', ToCardPath(MapPath) + '\offline\index.htm');
      end
      else begin
        //FTP
      end;
      LogWork(_('= Offline listings synchronized'));
      GB_Clean;
    end;

    // Synchronizace externich priloh kesi - GEOGET_DATADIR\attach)
    if GQSForm_cb_Sync_Attach.Checked and not GQSForm_rb_Offline.Checked then begin
      GB_Caption(_('Attachments are synchronized'));
      MakeDirPDA(MapPath + '\attach');            // pro jistotu v PDA zalozi adresar pro mapy, kdyby jeste nebyl
      // vlastni synchronizace
      if GQSForm_rb_CardReader.Checked then begin
        SmartCopyPC(GEOGET_DATADIR + '\attach'  , ToCardPath(MapPath) + '\Attach'  , '.*', _('synchronizing attachments, please wait...'));
      end
      else begin
        GB_Kind(_('synchronizing attachments, please wait...'));
        //FTP
      end;
      LogWork(_('= Attachments synchronized'));
      GB_Clean;
    end;

    if Sender <> GQSForm_btn_All then ShowResult(True);
  end;
  GQSForm.Show;
end;

{########################################################################################################################################################}
{## Web -> PDA ###########################################################################################################################################}
{########################################################################################################################################################}
procedure form_Web_PDA(Sender: TObject);
var 
  script         : string;
begin
  GQSForm.Hide;
  EndForm_mem_Result.Clear;
  GB_Clean;
  GB_Caption(_('Web to PDA sync'));
  SaveProfile('DEFAULT');

  ReadGQini(True, GQSForm_rb_CardReader.Checked); // Nacteni nastaveni GeoQuack z ini

  // Rychly import bodu do databaze GeoGetu pomoci gpx - pro rychly import novych kesi}
  if GQSForm_cb_ImportGpx.Checked and GQSForm_rb_FTP.Checked then begin
    GB_Caption(_('Fast import of GC to GeoQuack'));
    if FileExists(GEOGET_DATADIR + '\script\geojarry\gj2.exec.listing.ggc.pas') then begin
      DeleteFile(MakroPath + 'Data\GeoList_Imp.ggt');
      if GQSForm_rb_ImportGpx_GC.Checked then begin
        SaveIniStrValue('DEFAULT', 'ImportGpxID', GQSForm_ed_ImportGpxID.Text);                                
        if IsValidGC('GC' + GQSForm_ed_ImportGpxID.Text) then begin
          GB_Kind(_('Downloading of GC') + GQSForm_ed_ImportGpxID.Text + _(' from geocaching.com'));
          GC:= TGeo.Create();
          GC.ID := 'GC' + GQSForm_ed_ImportGpxID.Text; 
          GeoCallGGC(GEOGET_DATADIR + '\script\geojarry\gj2.exec.listing.ggc.pas', GC);
          GC.ID := ''; 
          GC.LoadByGC('GC' + GQSForm_ed_ImportGpxID.Text);
          DeleteFile(MakroPath + 'Data\GeoList_Imp.ggt');
          if (GC.ID <> NIL) and (GC.Updated = Date) then begin
            StringToFile(GC.ID, MakroPath + 'Data\GeoList_Imp.ggt');
          end
          else LogWork(_('# Error: GC') + GQSForm_ed_ImportGpxID.Text + _(' not imported - failed to download from the Web'));
          GC.Free;
        end
        else LogWork(_('# Error: GC') + GQSForm_ed_ImportGpxID.Text + _(' not imported - GC code not valid'));
      end
      else begin
        GB_Caption('Fast import of list to GeoQuack');
        CopyFile(MakroPath + 'Data\GeoList_Orig.ggt', MakroPath + 'Data\GeoList_Imp.ggt');
        NumOfImported := NumOfGCinList;
      end;
      if FileExists(MakroPath + 'Data\GeoList_Imp.ggt') then begin
        GB_Kind(_('Export to gpx'));
        // kolik bodu
        script := FileToString(MakroPath + 'Data\GeoList_Imp.ggt');
        repeat
          if RegexFind('GC\S{1,5}', FetchBin(script, CRLF)) then NumOfImported := NumOfImported + 1;
          GeoBusyProgress(NumOfImported, NumOfImported);
        until (script = '');
        // priprava seznamu pro export
        GeoListClear;
        GeoListFileAdd(MakroPath + 'Data\GeoList_Imp.ggt');
        // export seznamu do gpx souboru
        GeoExport(GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas', MakroPath + 'Data\FastGeo_Import.gpx');
        // prenos gpx souboru do PDA
        GB_Kind(_('Fast import of points to GeoQuack database'));
        MakeDirPDA(dbPath + '\GPX');       // pro jistotu v PDA zalozi adresar pro GPX, kdyby jeste nebyl
        //RunProc('"' + MakroPath + 'rapicopy.exe" "' + MakroPath + 'Data\FastGeo_Import.gpx" "' + '\FastGeo_Import.gpx' + '"', 'FastGeo_Copy', SetForm_cb_CmdWriteToFile.Checked);          // vlastni import do GeoQuack
        //RunProc('"' + MakroPath + 'rapistart.exe" "' + InstallPath + '\geoquack.exe" "/i \FastGeo_Import.gpx"', 'FastGeo_Import', SetForm_cb_CmdWriteToFile.Checked);
        //RunProc('"' + MakroPath + 'rapimove.exe" -d "\FastGeo_Import.gpx"', 'FastGeo_Del', SetForm_cb_CmdWriteToFile.Checked);
        if GQSForm_rb_ImportGpx_GC.Checked then LogWork(  '= GC' + GQSForm_ed_ImportGpxID.Text + _(' to GeoQuack database imported'))
                                           else LogWork(_('= Fast import of points to GeoQuack database done'));
      end
      else NumOfImported := 0;
    end
    else LogWork(_('# Error: Fast import not carried out - ') + GEOGET_DATADIR + _('\script\geojarry\gj2.exec.listing.ggc.pas not found'));
    GB_Clean;
  end;

  if Sender <> GQSForm_btn_All then ShowResult(True);
  GQSForm.Show;
end;

{########################################################################################################################################################}
// Vsechny funkce najednou
procedure form_All(Sender: TObject);
begin
  form_PDA_PC(Sender);
  form_PC_Web(Sender);
  form_PC_PDA(Sender);
  form_Web_PDA(Sender);
  ShowResult(True);
end;
