//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi jeden klic do ini souboru}
procedure SaveIniIntValue(Section: String; Key: String; Value: Integer);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    Ini_GQ.WriteInteger(Section, Key, Value);
  finally
    Ini_GQ.Free;
  end;
end;
procedure SaveIniStrValue(Section: String; Key: String; Value: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    Ini_GQ.WriteString(Section, Key, Value);
  finally
    Ini_GQ.Free;
  end;
end;
procedure SaveIniFloatValue(Section: String; Key: String; Value: Single);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    Ini_GQ.WriteFloat(Section, Key, Value);
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte jeden klic z ini souboru}
function LoadIniIntValue(Section: String; Key: String; InitValue: Integer): Integer;
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    Result := Ini_GQ.ReadInteger(Section, Key, InitValue);
  finally
    Ini_GQ.Free;
  end;
end;
function LoadIniStrValue(Section: String; Key: String; InitValue: String): String;
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    Result := Ini_GQ.ReadString(Section, Key, InitValue);
  finally
    Ini_GQ.Free;
  end;
end;
function LoadIniFloatValue(Section: String; Key: String; InitValue: Single): Single;
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    Result := Ini_GQ.ReadFloat(Section, Key, InitValue);
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi profil}
procedure SaveProfile(Name: String);
var
  Ini_GQ  : TIniFile;
  i       : integer;
begin
  if (Name <> 'DEFAULT') and (GQSForm_cmb_Profile.ItemIndex = -1) then
    GQSForm_cmb_Profile.Items.Add(Name);
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin
      EraseSection('PROFILES');
      for i:= 0 to GQSForm_cmb_Profile.Items.Count - 1 do begin
        WriteInteger('PROFILES', GQSForm_cmb_Profile.Items[i], i);
        if GQSForm_cmb_Profile.Items[i] = Name then GQSForm_cmb_Profile.ItemIndex := i;
      end;
      WriteBool   (Name, 'FTP'                   , GQSForm_rb_FTP                   .Checked  );
      WriteBool   (Name, 'CardReader'            , GQSForm_rb_CardReader            .Checked  );
      WriteBool   (Name, 'OffLine'               , GQSForm_rb_Offline               .Checked  );
      WriteBool   (Name, 'db_GG_Full'            , GQSForm_rb_db_GG_Full            .Checked  );
      WriteBool   (Name, 'db_GG_Filter'          , GQSForm_rb_db_GG_Filter          .Checked  );
      WriteBool   (Name, 'db_GQ_Default'         , GQSForm_rb_db_GQ_Default         .Checked  );
      WriteBool   (Name, 'db_GQ_Custom'          , GQSForm_rb_db_GQ_Custom          .Checked  );
      WriteString (Name, 'db_GQ_CustomName'      , GQSForm_cmb_db_GQ_CustomName     .Text     );
      WriteBool   (Name, 'Upd_db_GG'             , GQSForm_cb_Upd_db_GG             .Checked  );
      WriteBool   (Name, 'Gen_FieldNotes_GG'     , GQSForm_cb_Gen_FieldNotes_GG     .Checked  );
      WriteBool   (Name, 'Save_db_GQ'            , UpdGGForm_cb_Save_db_GQ          .Checked  );
      WriteBool   (Name, 'Upd_FieldNotes'        , UpdGGForm_cb_Upd_FieldNotes      .Checked  );
      WriteBool   (Name, 'Del_FieldNotes'        , UpdGGForm_cb_Del_FieldNotes      .Checked  );
      WriteBool   (Name, 'Upd_Tracks'            , UpdGGForm_cb_Upd_Tracks          .Checked  );
      WriteBool   (Name, 'Del_Tracks'            , UpdGGForm_cb_Del_Tracks          .Checked  );
      WriteBool   (Name, 'GQ_Ref_Points'         , UpdGQForm_cb_GQ_Ref_points       .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes'        , GQSForm_cb_Upl_FieldNotes        .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes_GG'     , GQSForm_rb_Upl_FieldNotes_GG     .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes_GQ'     , GQSForm_rb_Upl_FieldNotes_GQ     .Checked  );
      WriteBool   (Name, 'Upd_db_GQ'             , GQSForm_cb_Upd_db_GQ             .Checked  );
      WriteBool   (Name, 'Sync_Img'              , GQSForm_cb_Sync_Img              .Checked  );
      WriteBool   (Name, 'Sync_Attach'           , GQSForm_cb_Sync_Attach           .Checked  );
      WriteBool   (Name, 'ImportGpx'             , GQSForm_cb_ImportGpx             .Checked  );
      WriteBool   (Name, 'ImportGpx_GC'          , GQSForm_rb_ImportGpx_GC          .Checked  );
      WriteBool   (Name, 'ImportGpx_List'        , GQSForm_rb_ImportGpx_List        .Checked  );
      WriteBool   (Name, 'TrackTimeToTrimEnbl'   , TrkDivideForm_cb_TimeToTrimEnbl  .Checked  );
      WriteBool   (Name, 'TrackTrackToTrimEnbl'  , TrkDivideForm_cb_TrackToTrimEnbl .Checked  );
      WriteFloat  (Name, 'TrackTimeToTrim'       , TrkDivideForm_dt_TimeToTrim      .Time     );
      WriteInteger(Name, 'TrackTrackToTrim'      , StrToInt(TrkDivideForm_ed_DistToTrim.Text) );
      WriteBool   (Name, 'Map_geoKuk_Del'        , MapForm_cb_Geokuk_Del            .Checked  );
      WriteBool   (Name, 'Map_ShowInfo'          , MapForm_cb_ShowInfo              .Checked  );
    end;
  finally
    Ini_GQ.Free;
    LogWork(_('- profile saved: ') + Name);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna SetForm}
procedure SaveIniSetForm(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin  
      WriteBool   (Name, 'AutoUpdate',        SetForm_cb_AutoUpdate     .Checked);
      WriteBool   (Name, 'Log_Enbl',          SetForm_cb_Log_Enbl       .Checked);
      WriteBool   (Name, 'ShowResult_Enbl',   SetForm_cb_ShowResult_Enbl.Checked);
      WriteString (Name, 'FTP_IP',            SetForm_ed_FTP_IP         .Text);
      WriteString (Name, 'FTP_Port',          SetForm_ed_FTP_Port       .Text);
      WriteString (Name, 'FTP_User',          SetForm_ed_FTP_User       .Text);
      WriteString (Name, 'FTP_Pswd',          SetForm_ed_FTP_Pswd       .Text);
    end;
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna TrkForm}
procedure SaveIniTrkForm(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin  
      WriteBool   (Name, 'TrackTimeToTrimEnbl'   , TrkDivideForm_cb_TimeToTrimEnbl        .Checked  );
      WriteBool   (Name, 'TrackTrackToTrimEnbl'  , TrkDivideForm_cb_TrackToTrimEnbl       .Checked  );
      WriteFloat  (Name, 'TrackTimeToTrim'       , TrkDivideForm_dt_TimeToTrim            .Time     );
      WriteInteger(Name, 'TrackTrackToTrim'      , StrToInt(TrkDivideForm_ed_DistToTrim   .Text)    );
    end;
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna EndForm}
procedure SaveIniEndForm(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin  
      WriteBool   (Name, 'ShowList_ggf'          , EndForm_cb_ShowList_ggf          .Checked  );
      WriteString (Name, 'ShowList_ggfName'      , EndForm_cb_ShowList_ggfName      .Text     );
      WriteBool   (Name, 'ShowList_Orig'         , EndForm_cb_ShowList_Orig         .Checked  );
      WriteBool   (Name, 'ShowList_Upd'          , EndForm_cb_ShowList_Upd          .Checked  );
      WriteBool   (Name, 'ShowList_Imp'          , EndForm_cb_ShowList_Imp          .Checked  );
      WriteBool   (Name, 'ShowList_FN'           , EndForm_cb_ShowList_FN           .Checked  );
    end;
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna SetForm}
procedure ReadIniSetForm(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin
      SetForm_cb_AutoUpdate            .Checked   := ReadBool   (Name, 'AutoUpdate'             ,False);
      SetForm_cb_Log_Enbl              .Checked   := ReadBool   (Name, 'Log_Enbl'               ,True);
      SetForm_cb_ShowResult_Enbl       .Checked   := ReadBool   (Name, 'ShowResult_Enbl'        ,True);
      SetForm_ed_FTP_IP                .Text      := ReadString (Name, 'FTP_IP'                 ,'192.168.2.26');
      SetForm_ed_FTP_Port              .Text      := ReadString (Name, 'FTP_Port'               ,'1025');
      SetForm_ed_FTP_User              .Text      := ReadString (Name, 'FTP_User'               ,'User');
      SetForm_ed_FTP_Pswd              .Text      := ReadString (Name, 'FTP_Pswd'               ,'Pasword');
    end;
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna TrkForm}
procedure ReadIniTrkForm(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin
      TrkDivideForm_cb_TimeToTrimEnbl        .Checked   := ReadBool   (Name, 'TrackTimeToTrimEnbl'    ,False);
      TrkDivideForm_cb_TrackToTrimEnbl       .Checked   := ReadBool   (Name, 'TrackTrackToTrimEnbl'   ,False);
      TrkDivideForm_dt_TimeToTrim            .Time      := ReadFloat  (Name, 'TrackTimeToTrim'        ,0.041667);  // 1h
      TrkDivideForm_ed_DistToTrim            .Text      := IntToStr(ReadInteger(Name, 'TrackTrackToTrim',10));
    end;
  finally
    Ini_GQ.Free;
  end;
end;

//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna EndForm}
procedure ReadIniEndForm(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin
      EndForm_cb_ShowList_ggf          .Checked   := ReadBool   (Name, 'ShowList_ggf'           ,False);
      EndForm_cb_ShowList_ggfName      .Text      := ReadString (Name, 'ShowList_ggfName'       ,'Default');
      EndForm_cb_ShowList_Orig         .Checked   := ReadBool   (Name, 'ShowList_Orig'          ,False);
      EndForm_cb_ShowList_Upd          .Checked   := ReadBool   (Name, 'ShowList_Upd'           ,True);
      EndForm_cb_ShowList_Imp          .Checked   := ReadBool   (Name, 'ShowList_Imp'           ,True);
      EndForm_cb_ShowList_FN           .Checked   := ReadBool   (Name, 'ShowList_FN'            ,True);
    end;
  finally
    Ini_GQ.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte profil z ini souboru}
procedure ReadProfile(Name: String);
var Ini_GQ : TIniFile;
begin
  Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
  try
    with Ini_GQ do
    begin
      if GQSForm_cmb_Profile.Items.Count = 0 then begin
        ReadSection('PROFILES', GQSForm_cmb_Profile.Items);
      end;
      GQSForm_rb_FTP                   .Checked   := ReadBool   (Name, 'FTP'                    ,False);
      GQSForm_rb_CardReader            .Checked   := ReadBool   (Name, 'CardReader'             ,True);
      GQSForm_rb_Offline               .Checked   := ReadBool   (Name, 'OffLine'                ,False);
      GQSForm_rb_db_GG_Full            .Checked   := ReadBool   (Name, 'db_GG_Full'             ,True);
      GQSForm_rb_db_GG_Filter          .Checked   := ReadBool   (Name, 'db_GG_Filter'           ,False);
      GQSForm_rb_db_GQ_Default         .Checked   := ReadBool   (Name, 'db_GQ_Default'          ,True);
      GQSForm_rb_db_GQ_Custom          .Checked   := ReadBool   (Name, 'db_GQ_Custom'           ,False);
      GQSForm_cmb_db_GQ_CustomName     .Text      := ReadString (Name, 'ed_GQ_CustomName'       ,'cachedb_bak');
      GQSForm_cb_Upd_db_GG             .Checked   := ReadBool   (Name, 'Upd_db_GG'              ,False);
      GQSForm_cb_Gen_FieldNotes_GG     .Checked   := ReadBool   (Name, 'Gen_FieldNotes_GG'      ,False);
      UpdGGForm_cb_Save_db_GQ          .Checked   := ReadBool   (Name, 'Save_db_GQ'             ,False);
      UpdGGForm_cb_Upd_FieldNotes      .Checked   := ReadBool   (Name, 'Upd_FieldNotes'         ,False);
      UpdGGForm_cb_Del_FieldNotes      .Checked   := ReadBool   (Name, 'Del_FieldNotes'         ,False);
      UpdGGForm_cb_Upd_Tracks          .Checked   := ReadBool   (Name, 'Upd_Tracks'             ,False);
      UpdGGForm_cb_Del_Tracks          .Checked   := ReadBool   (Name, 'Del_Tracks'             ,False);
      UpdGQForm_cb_GQ_Ref_points       .Checked   := ReadBool   (Name, 'GQ_Ref_Points'          ,False);
      GQSForm_cb_Upl_FieldNotes        .Checked   := ReadBool   (Name, 'Upl_FieldNotes'         ,False);
      GQSForm_rb_Upl_FieldNotes_GG     .Checked   := ReadBool   (Name, 'Upl_FieldNotes_GG'      ,True);
      GQSForm_rb_Upl_FieldNotes_GQ     .Checked   := ReadBool   (Name, 'Upl_FieldNotes_GQ'      ,False);
      GQSForm_cb_Upd_db_GQ             .Checked   := ReadBool   (Name, 'Upd_db_GQ'              ,False);
      GQSForm_cb_Sync_Img              .Checked   := ReadBool   (Name, 'Sync_Img'               ,False);
      GQSForm_cb_Sync_Attach           .Checked   := ReadBool   (Name, 'Sync_Attach'            ,False);
      GQSForm_cb_ImportGpx             .Checked   := ReadBool   (Name, 'ImportGpx'              ,False);
      GQSForm_rb_ImportGpx_GC          .Checked   := ReadBool   (Name, 'ImportGpx_GC'           ,True);
      GQSForm_rb_ImportGpx_List        .Checked   := ReadBool   (Name, 'ImportGpx_List'         ,False);
      MapForm_cb_Geokuk_Del            .Checked   := ReadBool   (Name, 'Map_Geokuk_Del'         ,False);
      MapForm_cb_ShowInfo              .Checked   := ReadBool   (Name, 'Map_ShowInfo'           ,False);
      if (Name = 'DEFAULT') or (Name = 'FACTORY') then begin
        CardPath                                    := ReadString (Name, 'CardPath'               ,'');
        IniFile                                     := ReadString (Name, 'IniFile'                ,'GeoQuack/GeoQuack.ini');
        MobAtlCrPath                                := ReadString (Name, 'LastMobAtlCrPath'       ,'');
        OziMapPath                                  := ReadString (Name, 'LastOziMapPath'         ,'');
        GQSForm_dt_db_LastUpdate_Date    .Date      := Trunc(ReadFloat(Name, 'db_LastDownload'    ,Now - 1));
        GQSForm_dt_db_LastUpdate_Time    .Time      :=       ReadFloat(Name, 'db_LastDownload'    ,Now) - GQSForm_dt_db_LastUpdate_Date.Date;
        GQSForm_dt_FN_LastUpdate_Date    .Date      := Trunc(ReadFloat(Name, 'FN_LastUpdate'      ,Now - 1));
        GQSForm_dt_FN_LastUpdate_Time    .Time      :=       ReadFloat(Name, 'FN_LastUpdate'      ,Now) - GQSForm_dt_FN_LastUpdate_Date.Date;
        GQSForm_ed_ImportGpxID           .Text      := ReadString (Name, 'ImportGpxID'            ,'12345');
        ReadIniSetForm(Name);
        ReadIniEndForm(Name);
      end;
    end;
  finally
    Ini_GQ.Free;
    LogWork(_('- profile loaded: ') + Name);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - Ulozi profil do ini souboru}
procedure form_SaveProfile(Sender: TObject);
begin
  if GQSForm_cmb_Profile.Text = '' then
    ShowMessage(_('Enter a profile name'))
  else begin
    SaveProfile(GQSForm_cmb_Profile.Text);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - nacteni factory settings}
procedure form_ReadFactoryProfile(Sender: TObject);
begin
    ReadProfile('FACTORY');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - obsluha vyberu profilu}
procedure form_ProfileChanged(Sender: TObject);
begin
  if (GQSForm_cmb_Profile.ItemIndex <> -1) and (GQSForm_cmb_Profile.Items.Count > 0) then begin
    ReadProfile(GQSForm_cmb_Profile.Text);
    GQSForm_btn_Del.Enabled := true;
  end 
  else
    GQSForm_btn_Del.Enabled := false;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - smaze profil}
procedure form_DelProfile(Sender: TObject);
var
  Ini_GQ: TIniFile;
  i : Integer;
begin
  if GQSForm_cmb_Profile.ItemIndex <> -1 then begin
    Ini_GQ := TIniFile.Create(MakroPath + 'GeoQuackSync.ini');
    try
      Ini_GQ.EraseSection(GQSForm_cmb_Profile.Text);
      Ini_GQ.EraseSection('PROFILES');
      GQSForm_cmb_Profile.Items.Delete(GQSForm_cmb_Profile.ItemIndex);
      for i:= 0 to GQSForm_cmb_Profile.Items.Count - 1 do
        Ini_GQ.WriteInteger('PROFILES', GQSForm_cmb_Profile.Items[i], i);
    finally
      Ini_GQ.Free;
    end;
    if GQSForm_cmb_Profile.Items.Count > 0 then begin
      GQSForm_cmb_Profile.ItemIndex := 0;
      GQSForm_cmb_Profile.Text := GQSForm_cmb_Profile.Items[0];
      ReadProfile(GQSForm_cmb_Profile.Text)
    end
    else begin
      GQSForm_cmb_Profile.ItemIndex := -1;
      GQSForm_cmb_Profile.Text := '';
    end;
    if GQSForm_cmb_Profile.Items.Count = 0 then GQSForm_btn_Del.Enabled := false;
  end;
end;
//===============================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte String klic z registru PC - HKEY_CURRENT_USER}
function ReadRegString(RegPath: String; RegKey: String): String;
var reg : TRegistry;
begin
  reg := TRegistry.Create;
  try
    // reg.RootKey:='HKEY_CURRENT_USER';
    if reg.OpenKey(RegPath, False) then
      result := reg.ReadString(RegKey);
  finally
    reg.Free;
  end;
end;
