//-------------------------------------------------------------------------------------------------------------------------------
{Nacteni nastaveni z GeoQuack.ini}
procedure ReadGQini(All: Boolean; Online: Boolean);
var
  Ini       : TIniFile;
  FormShowed: Boolean;
begin
  // nacteni nastaveni z GeoQuack.ini
  FormShowed := GQSForm.Visible and not (TrkForm.Visible or MapForm.Visible);
  if FormShowed then GQSForm.Hide;
  GB_Caption(_('Settings is loading...'));  
  if Online then begin
    GB_Kind(_('uploading of GeoQuack.ini file from PDA')); 
    if FileExists(CardPath + IniFile) then begin
      CopyFile(CardPath + IniFile, MakroPath + 'Data\GeoQuack.ini');
    end
    else begin
      ShowErrorMessage(_('File not found:') + CRLF + CardPath + IniFile + CRLF + CRLF + _('- uploading of GeoQuack.ini') + _(' failed'));
      LogWork(_('# Error:') + ' ' + _('File not found:') + ' ' + CardPath + IniFile);
    end;
  end;
  GB_Kind(_('reading of GQ settings from GeoQuack.ini'));
  if not FileExists(MakroPath + 'Data\GeoQuack.ini') then begin
    LogWork(_('# Error:') + ' ' + _('File not found:') + ' ' + MakroPath + 'Data\GeoQuack.ini');
    ShowErrorMessage(_('File not found:') + CRLF + MakroPath + 'Data\GeoQuack.ini' + CRLF + CRLF +
                     _('If you use Off Line mode,')+
                     _('you have to connect device at least once by CardReader mode before.') + CRLF + CRLF +
                     _('If you use GQS for the first time, click on YES button.'));
  end
  else begin                     
    Ini := TIniFile.Create(MakroPath + 'Data\GeoQuack.ini');
    dbFile     := LowerCase(Ini.ReadString('Options', 'DbFile', ''));
    dbFile     := ReplaceString(dbFile, '/', '\');                 // pro jistotu nahradit opacna lomitka Mudlodcery :-)
    dbFile     := ReplaceString(dbFile, '\mnt\sdcard\', '');       // odstrani Android cestu ke karte                        ('geoquack\db.db3')
    dbName     := RegexExtract('[^\\]+\.db3', dbFile);             //                                                        ('db.db3')
    dbPath     := ReplaceString(dbFile, '\' + dbName, '');         //                                                        ('geoquack')
    if All then begin
      FNFile     := dbPath + '\fieldnotes.txt'                     //Ini.ReadString('Options', 'FNFile', '');                ('geoquack\fieldnotes.txt')
      FNFile     := ReplaceString(FNFile, '/', '\');               // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      FNName     := RegexExtract('[^\\]+\S$', FNFile);             //                                                        ('fieldnotes.txt')
      FNPath     := ReplaceString(FNFile, '\' + FNName, '');       //                                                        ('geoquack')
      FNTemplate := Ini.ReadString('Options', 'FNTemplate', '[T] #[N]\x0d\x0a[L]');
      TrackPath  := LowerCase(Ini.ReadString('Options', 'TrackFolder', ''));
      TrackPath  := ReplaceString(TrackPath, '/', '\');            // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      TrackPath  := ReplaceString(TrackPath, '\mnt\sdcard\', '');  // odstrani Android cestu ke karte                        ('geoquack\')
      TrackPath  := RegexReplace('\\$', TrackPath,'',False);       //                                                        ('geoquack')
      MapPath    := LowerCase(Ini.ReadString('Options', 'MapFolder', ''));
      MapPath    := ReplaceString(MapPath, '/', '\');              // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      MapPath    := ReplaceString(MapPath, '\mnt\sdcard\', '');    // odstrani Android cestu ke karte                        ('geoquack\')
      MapPath    := RegexReplace('\\$', MapPath,'',False);         //                                                        ('geoquack')
      InstallPath:= LowerCase(Ini.ReadString('Options',  'InstallDir', ''));
      InstallPath:= ReplaceString(InstallPath, '/', '\');          // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      InstallPath:= ReplaceString(InstallPath, '\mnt\sdcard\', '');// odstrani Android cestu ke karte                        ('geoquack\')
      InstallPath:= RegexReplace('\\$', InstallPath,'',False);     //                                                        ('geoquack')
      GQver      := Ini.ReadString('CurrentVersion', 'Version', '?.?.?.?');
      GQLang     := Ini.ReadString('Options', 'Language', 'en');
    end;
    // testuje zda se podarilo nacist vsechna nutna nastaveni z ini souboru
    if dbFile = '' then begin 
      LogWork(_('# Error:') + ' ' + _('Location of GeoQuack database failed!'));
      ShowErrorMessage(_('Location of GeoQuack database failed!')+CRLF+
                       _('Check settings of GeoQuack (Settings/General/Database file).')+CRLF+
                       _('Then you have to connect device at least once by ActiveSync mode.'));
    end
    else begin
      if dbName = '' then begin
        LogWork(_('# Error:') + ' ' + _('Name recognition of GeoQuack database failed!'));
        ShowErrorMessage(_('Name recognition of GeoQuack database failed!')+CRLF+
                         _('Check settings of GeoQuack (Settings/General/Database file).')+CRLF+
                         _('Then you have to connect device at least once by ActiveSync mode.'));
      end
      else begin
        if All then begin
          // kontrola verze GeoQuack
          if CompareVer(GQver_Min, GQver) then begin            // pokud verze GQ < GQver_Min 
            LogWork(_('# Error:') + ' GeoQuack ' + GQver + _(' - unsupported version! Required min. GeoQuack ') + GQver_Min);
            ShowErrorMessage(_('For proper operation is required GeoQuack version ') + GQver_Min + _(' or higher') +CRLF+ _('Your version: ') + GQver);
          end;
          // kontrola nastaveni
          if (FNFile     = '') and UpdGGForm_cb_Upd_FieldNotes.Checked then begin
            LogWork(_('# Error:') + ' ' + _('Location of FieldNotes failed!'));
            ShowErrorMessage(_('Location of FieldNotes failed!')+CRLF+
                             _('Check settings of GeoQuack (Export FieldNotes/File for export).')+CRLF+
                             _('Then you have to connect device at least once by ActiveSync mode.'));
          end;
          if (FNTemplate = '') and GQSForm_cb_Gen_FieldNotes_GG.Checked then begin 
            LogWork(_('# Error:') + ' ' + _('Reading of FieldNotes template failed!'));
            ShowErrorMessage(_('Reading of FieldNotes template failed!')+CRLF+
                             _('Check settings of GeoQuack (Export FieldNotes/Log template).')+CRLF+
                             _('Then you have to connect device at least once by ActiveSync mode.'));
          end;
          if (TrackPath  = '') and UpdGGForm_cb_Upd_Tracks.Checked then begin 
            LogWork(_('# Error:') + ' ' + _('Location of Tracks failed!'));
            ShowErrorMessage(_('Location of Tracks failed!')+CRLF+
                             _('Check settings of GeoQuack (Export Track/Folder for export).')+CRLF+
                             _('Then you have to connect device at least once by ActiveSync mode.'));
          end;
          if Online then begin
            //zkopiruje map-config.xml                       
            //DeleteFiles(MakroPath + 'Data\map-config*.xml');        // odstrani puvodni soubory
            //RunProc('"' + MakroPath + 'rapisync.exe" -w "map-config*.xml" -r -d "' + InstallPath + '" "' + MakroPath + 'Data' + '"', 'Sync_MapConfig', True);
          end; 
        end;
      end;
    end;
  end;
  LogWork(_('= Settings loading done.'));
  GB_Clean;
  if FormShowed then GQSForm.Show;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Kontrola pritomnosti GQ na SD karte}
function GQCard: Boolean;
begin
  Result := True;
  if GQSForm_rb_CardReader.Checked then begin    
    if not FileExists(ToCardPath(dbFile)) then begin
      LogWork(_('# Selected GeoQuack external disc not contains database: ') + ToCardPath(dbFile));
      if (MessBox(_('File not found on selected disc:') + CRLF + ToCardPath(dbFile) + CRLF + CRLF +
                  _('Probably it is not the GeoQuack data disc.') + CRLF + CRLF + _('Continue plugin execution?'), _('Attention!'), 4) <> 6) then Result := False;
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Podpora pripojeni pres externi disk}
procedure form_CardPath(Sender: TObject);
var
  script : String;
begin
//  script := SelectDir(CardPath, _('Select GeoQuack database on a mass storage...')+CRLF+_('Example: E:\'));
  OpenDlg(_('Select GeoQuack.ini on a mass storage'), CardPath + IniFile, 'ofFileMustExist,ofHideReadOnly', 'GeoQuack Stettings File (GeoQuack.ini)|GeoQuack.ini', Script);
  if script <> '' then begin
    CardPath := RegexExtract('^\w:\\', script);             //vykousne pouze pismeno disku [j:\]
    IniFile  := Trim(ReplaceString(Script, CardPath, ''));  //zbytek cesty k ini souboru GQ, bez pismenka disku
    GQSForm_ed_GQ_IniFile.Text  := IniFile;
    GQSForm_ed_GQ_disc   .Text  := CardPath;
    MapForm_ed_GQ_disc   .Text  := CardPath;
    SaveIniStrValue('DEFAULT', 'CardPath', CardPath);  
    SaveIniStrValue('DEFAULT', 'IniFile' , IniFile);  
    LogWork(_('- GeoQuack external disc selected: ') + CardPath);
    ReadGQini(False, True);    //nacte ini soubor z disku a naplni promenne
    GQCard;                    //kontrola nastaveni disku s GQ
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{zjisteni cesty k mapovym kachlim programu GeoKuk}
function SmartPath_GK(path: String): String;
begin
  Result := ReadRegString('\Software\JavaSoft\Prefs\geokuk\current\umisteni/Souboru', 'kachle/Cache/Dir');
  StringToFile(result, Makropath + 'Data\reg_GeoKuk.txt'); // pro testovaci ucely
  Result := RegexReplace('/{2,5}', Result, '\', False);                         // nahradi '//|///|...' z retezce registru znakem '\' (co se to tam do toho registru uklada za nesmysly!!??)
  Result := ReplaceString(Result, '/', '');                                     // odmazne zbyla samostatna '/' z retezce, pokud tam jsou (se tam nejak zbytecne nacpaly na divny mista)
  Result := ReplaceString(path, '<auto>', Result);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - zjisteni databazi v PDA}
procedure form_dbSeek(Sender: TObject);
var 
  script : string;
begin
  if not GQSForm_rb_Offline.Checked then begin
    ReadGQini(False, GQSForm_rb_CardReader.Checked);  // nacte si nastaveni z ini
    if GQCard then begin     // otestuje umisteni GQ na externim disku
      if GQSForm_rb_CardReader.Checked then script := 'dir "' + ToCardPath(dbPath) + '\*.db3" /B';
      if GQSForm_rb_FTP       .Checked then script := 'rem UNSUPORTED';
      RunProc(script, 'dbList_PDA', True);
      if FileExists(MakroPath + 'Data\dbList_PDA.txt') then begin
        script := LowerCase(FileToString(MakroPath + 'Data\dbList_PDA.txt'));
        if (script = '') OR (pos('WARNING', script) <> 0) then ShowMessage(_('Reading of database list failed.')+CRLF+CRLF+_('Error code:') +CRLF+ script)
        else begin
          script := RegexExtract('[^\s]+\.db3', script);
          GQSForm_cmb_db_GQ_CustomName.Items.Clear;
          while trim(script) <> '' do begin
            GQSForm_cmb_db_GQ_CustomName.Items.Add(SeparateLeft(FetchBin(script, CRLF), '.db3'));
          end;
          GQSForm_cmb_db_GQ_CustomName.ItemIndex := GQSForm_cmb_db_GQ_CustomName.Items.Count - 1;
        end;
      end
      else ShowMessage(_('Error: Creating of database list failed.'));
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Priprava pracovni databaze GeoGetu -  v pripade ze se pracuje pouze s vyfiltrovanym seznamem}
procedure dbWorkListCreate();
begin
  if GQSForm_rb_db_GG_Filter.Checked then begin
    GB_Caption(_('Temporary GeoGet database is prepared'));   
    // export zmen do gpx souboru
    GB_Kind(_('the filtered cache list is exported...'));
    StringToFile('GC0', MakroPath + 'Data\GC0.ggt');  //pro doplneni GC0 (Add-hoc WP) do seznamu
    GeoListFileAdd(MakroPath + 'Data\GC0.ggt');
    DeleteFile(MakroPath + 'Data\GeoGetFilter_db.gpx');
    GeoExport(GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas', MakroPath + 'Data\GeoGetFilter_db.gpx');
    if not FileExists(MakroPath + 'Data\GeoGetFilter_db.gpx') then begin
      LogWork('# ' +   _('Error: File "') + MakroPath + 'Data\GeoGetFilter_db.gpx' + _('" not found!'));
      ShowErrorMessage(_('Error: File "') + MakroPath + 'Data\GeoGetFilter_db.gpx' + _('" not found!') + CRLF 
                     + _('Check export macro: ') + CRLF + GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas');
    end;
    // vytvori pracovni databazi
    GeoDBSelect('$GeoQuack_Work$');                    // zalozi pracovni databazi
    GB_Kind(_('the list is imported to a work database...'));
    GeoImportFile(MakroPath + 'Data\GeoGetFilter_db.gpx');
    GeoDBSelect(GQSForm_lbl_db_GG_Name.Caption);          // prepne na aktivni databazi
    GB_Clean;
  end
  else CopyFile(GEOGET_DATADIR + '\' + GEOGET_DBNAME + '.db3', GEOGET_DATADIR + '\' + '$GeoQuack_Work$.db3');
  LogWork(_('- Temporary GG database created: $GeoQuack_Work$'));
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Naplni StringList soubory z daneho adresare vcetne podadresaru}
procedure FileAllList(Dir, RegexMaskPath, RegexMaskFile: string; List: TStringList);
var
  Files,Queue  : TStringList;
  n : Integer;
begin
  if DirectoryExists(Dir) then begin
    Queue    := TStringList.Create;
    Files    := TStringList.Create;
    try
      Queue.Add(Dir);
      while (Queue.Count > 0) do begin
        if GB_Test then Break;  //preruseno uzivatelem
        GB_Progress(1, Trunc(sqrt(List.Count)) ,Trunc(sqrt(List.Count))+1);
        FileList(Queue[0],Files); Queue.Delete(0);
        for n := 0 to Files.Count-1 do begin
          if RegexFind('\\$',Files[n]) then begin if RegexFind(RegexMaskPath,Files[n]) then Queue.Add(Files[n]); end
                                       else begin if RegexFind(RegexMaskFile,Files[n]) then List.Add(Files[n]);  end;
        end;
      end;
      GB_Progress(1, 0 ,100);
    finally;
      Queue.Free; Files.Free;
    end;
  end;
end;  
//===============================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------
{Kopiruje obsah adresare PC<->PC vcetne podslozek, pouze soubory dle zadane regex masky}
procedure SmartCopyPC(FromDir: string; ToDir: string; RegexMaskFile: string; Caption: string);
var
  Files        : TStringList;
  NameDestFile : string;
  n : Integer;
begin
  if not RegexFind('\\$',FromDir) then FromDir := FromDir + '\';
  if not RegexFind('\\$',ToDir)   then ToDir   := ToDir   + '\';
  if DirectoryExists(FromDir) then begin
    GB_Caption(Caption);
    Files    := TStringList.Create;
    try
      GB_Kind(_('files are calculated:') + RegexExtract('[^\\]+\S$',FromDir) + RegexMaskFile);
      GB_Value(FromDir + RegexMaskFile);
      FileAllList(FromDir, '.*', RegexMaskFile, Files);   //naplni seznam vsech souboru z adresare a jeho podadresaru
      GB_Kind(_('files are copied: ') + RegexExtract('[^\\]+\S$',FromDir) + RegexMaskFile);
      for n := 0 to Files.Count-1 do begin
        GB_Progress(1, n ,Files.Count);
        NameDestFile   := ToDir + ReplaceString(Files[n], FromDir, '');
        MakeDirPC(ReplaceString(NameDestFile, RegexExtract('[^\\]+\S$',NameDestFile), ''));
        CopyFile(Files[n], NameDestFile);
        if GB_Test then Break;  //preruseno uzivatelem
      end;
      LogWork(' .. SmartCopyPC: ' + Caption);
    finally
      Files.Free;
    end;
    GB_Clean;
  end;
end;
